# coding: utf-8

"""
    PDS Registry Search API

    Registry API enabling advanced search on PDS data and metadata. The API provides end-points to search for bundles, collections and any PDS products with advanced search queries. It also enables to browse the archive hierarchically downward (e.g. collection/s products) or upward (e.g. bundles containing a product). 

    The version of the OpenAPI document: 1.6.0
    Contact: pds-operator@jpl.nasa.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Pds4MetadataOpsDataFile(BaseModel):
    """
    Pds4MetadataOpsDataFile
    """ # noqa: E501
    opscreation_date: Optional[StrictStr] = Field(default=None, alias="ops:creation_date")
    opsfile_name: Optional[StrictStr] = Field(default=None, alias="ops:file_name")
    opsfile_ref: Optional[StrictStr] = Field(default=None, alias="ops:file_ref")
    opsfile_size: Optional[StrictStr] = Field(default=None, alias="ops:file_size")
    opsmd5_checksum: Optional[StrictStr] = Field(default=None, alias="ops:md5_checksum")
    opsmime_type: Optional[StrictStr] = Field(default=None, alias="ops:mime_type")
    __properties: ClassVar[List[str]] = ["ops:creation_date", "ops:file_name", "ops:file_ref", "ops:file_size", "ops:md5_checksum", "ops:mime_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Pds4MetadataOpsDataFile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Pds4MetadataOpsDataFile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ops:creation_date": obj.get("ops:creation_date"),
            "ops:file_name": obj.get("ops:file_name"),
            "ops:file_ref": obj.get("ops:file_ref"),
            "ops:file_size": obj.get("ops:file_size"),
            "ops:md5_checksum": obj.get("ops:md5_checksum"),
            "ops:mime_type": obj.get("ops:mime_type")
        })
        return _obj


